static char rcsid[] = "$Id: safeopen.c,v 2.2 2011-03-06 19:52:58 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 2.2 $   $State: Exp $
 *
 *  Modified by: Kari Hurtta <hurtta+elm@siilo.FMI.FI> 
 *                       (was hurtta+elm@posti.FMI.FI, hurtta+elm@ozone.FMI.FI)
 *           or  Kari Hurtta <elm@elmme-mailer.org>
 *
 *  Initially written by: Zoltan Hidvegi <hzoli@cs.elte.hu>
 *****************************************************************************/

#include "elm_defs.h"

FILE *safeopen(name)
     char *name;
{
    FILE *fp;
    int fd = open(name, O_WRONLY | O_CREAT | O_EXCL, 0600);

    if (fd < 0 &&
	(unlink(name) ||
	 (fd = open(name, O_WRONLY | O_CREAT | O_EXCL, 0600)) < 0))
	return NULL;

    if (! (fp = fdopen(fd, "w"))) {
      close(fd);
      unlink(name);
    }
    return fp;
}

FILE *safeopen_rdwr(name)
     char *name;
{
    FILE *fp;
    int fd = open(name, O_RDWR | O_CREAT | O_EXCL, 0600);

    if (fd < 0 &&
	(unlink(name) ||
	 (fd = open(name, O_RDWR | O_CREAT | O_EXCL, 0600)) < 0))
	return NULL;

    if (! (fp = fdopen(fd, "w+"))) {
      close(fd);
      unlink(name);
    }
    return fp;
}

/*
 * Local Variables:
 *  mode:c
 *  c-basic-offset:4
 *  buffer-file-coding-system: iso-8859-1
 * End:
 */
